#ifndef LC_PROT_LCPU___FILEWRITEPROGRAM__H
#define LC_PROT_LCPU___FILEWRITEPROGRAM__H

#include <LC3CGBase.h>
#include <lcfu___strtobytearr.h>
#include <lcfu_iec61131__IOR.h>
#include <lcfu_iec61131__LEN.h>
#include <lcfu_iec61131__NOT.h>
#include <lcfu_logilibrary__SYSTEM_CLOSE.h>
#include <lcfu_logilibrary__SYSTEM_OPEN.h>
#include <lcfu_logilibrary__SYSTEM_WRITE.h>
#include <lcpu___filewriteprogram.gv.h>

/*                            Typedefs                         */
typedef struct _LC_TD_Program_FILEWRITEPROGRAM
{
  LC_TD_BOOL LC_VD_ENO;
  LC_TD_BOOL LC_VD_INIT;
  LC_TD_DINT LC_VD_FILEDESCRIPTOR;
  LC_TD_DINT LC_VD_FLAGS;
  LC_TD_DINT LC_VD_FLAGSCREATETRUNCWRITE;
  LC_TD_DINT LC_VD_FLAGSWRITEAPPEND;
  LC_TD_DINT LC_VD_LINUX_O_APPEND;
  LC_TD_DINT LC_VD_LINUX_O_CREAT;
  LC_TD_DINT LC_VD_LINUX_O_EXCL;
  LC_TD_DINT LC_VD_LINUX_O_RDONLY;
  LC_TD_DINT LC_VD_LINUX_O_RDWR;
  LC_TD_DINT LC_VD_LINUX_O_TRUNC;
  LC_TD_DINT LC_VD_LINUX_O_WRONLY;
  LC_TD_DINT LC_VD_MODE;
  LC_TD_DINT LC_VD_WRITECOUNTER;
  LcCgChar LC_VD_MY_STRING[65];
  LC_TD_BYTE LC_VD_DATA[64];
} LCCG_StructAttrib LC_TD_Program_FILEWRITEPROGRAM;

/*                   ColdBoot Initialization Macro             */
#define LC_INIT_NONDMA_Program_FILEWRITEPROGRAM(p) \
  (p)->LC_VD_LINUX_O_APPEND = (LC_TD_DINT)1024L; \
  (p)->LC_VD_LINUX_O_CREAT = (LC_TD_DINT)64L; \
  (p)->LC_VD_LINUX_O_EXCL = (LC_TD_DINT)128L; \
  (p)->LC_VD_LINUX_O_RDONLY = (LC_TD_DINT)0L; \
  (p)->LC_VD_LINUX_O_RDWR = (LC_TD_DINT)2L; \
  (p)->LC_VD_LINUX_O_TRUNC = (LC_TD_DINT)512L; \
  (p)->LC_VD_LINUX_O_WRONLY = (LC_TD_DINT)1L; \
  (p)->LC_VD_INIT = LC_EL_true; \
  (p)->LC_VD_WRITECOUNTER = (LC_TD_DINT)0L; \
  (p)->LC_VD_FILEDESCRIPTOR = (LC_TD_DINT)0L; \
  LC_INIT_ARRAY(&((p)->LC_VD_DATA),BYTE,64); \
  (p)->LC_VD_FLAGSWRITEAPPEND = (LC_TD_DINT)-1L; \
  (p)->LC_VD_FLAGSCREATETRUNCWRITE = (LC_TD_DINT)-1L; \
  (p)->LC_VD_FLAGS = (LC_TD_DINT)-1L; \
  (p)->LC_VD_MODE = (LC_TD_DINT)0L; \
  LC_INIT_SIZED_STRING_VAL((p)->LC_VD_MY_STRING,64,"Hello World"); \

#define LC_INIT_Program_FILEWRITEPROGRAM(p) \
{ \
  LC_INIT_NONDMA_Program_FILEWRITEPROGRAM(p) \
}

/*                   WarmBoot Initialization Macro             */
#define LC_WINIT_NONDMA_Program_FILEWRITEPROGRAM(p,RF) \
  if (RF==0) (p)->LC_VD_LINUX_O_APPEND = (LC_TD_DINT)1024L; \
  if (RF==0) (p)->LC_VD_LINUX_O_CREAT = (LC_TD_DINT)64L; \
  if (RF==0) (p)->LC_VD_LINUX_O_EXCL = (LC_TD_DINT)128L; \
  if (RF==0) (p)->LC_VD_LINUX_O_RDONLY = (LC_TD_DINT)0L; \
  if (RF==0) (p)->LC_VD_LINUX_O_RDWR = (LC_TD_DINT)2L; \
  if (RF==0) (p)->LC_VD_LINUX_O_TRUNC = (LC_TD_DINT)512L; \
  if (RF==0) (p)->LC_VD_LINUX_O_WRONLY = (LC_TD_DINT)1L; \
  if (RF==0) (p)->LC_VD_INIT = LC_EL_true; \
  if (RF==0) (p)->LC_VD_WRITECOUNTER = (LC_TD_DINT)0L; \
  if (RF==0) (p)->LC_VD_FILEDESCRIPTOR = (LC_TD_DINT)0L; \
  LC_WINIT_ARRAY(&((p)->LC_VD_DATA),BYTE,64,RF); \
  if (RF==0) (p)->LC_VD_FLAGSWRITEAPPEND = (LC_TD_DINT)-1L; \
  if (RF==0) (p)->LC_VD_FLAGSCREATETRUNCWRITE = (LC_TD_DINT)-1L; \
  if (RF==0) (p)->LC_VD_FLAGS = (LC_TD_DINT)-1L; \
  if (RF==0) (p)->LC_VD_MODE = (LC_TD_DINT)0L; \
  if (RF==0) LC_INIT_SIZED_STRING_VAL((p)->LC_VD_MY_STRING,64,"Hello World"); \

#define LC_WINIT_Program_FILEWRITEPROGRAM(p,RF) \
{ \
  LC_WINIT_NONDMA_Program_FILEWRITEPROGRAM(p,RF) \
}

#define LCNS_EL_INI___FILEWRITEPROGRAM \
  { \
    {\
      sizeof(RTTypeNS_ElementNode), \
      "DATA", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_DATA), \
      64 * sizeof(LC_TD_BYTE), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_BYTE, \
      "BYTE", \
      NULL, \
      NULL, \
      NULL, \
      &lcns_arrayNode___FILEWRITEPROGRAM_DATA, \
      0 \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "ENO", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_ENO), \
      sizeof(LC_TD_BOOL), \
      LCOOS_VAREXP_VAR_OUTPUT, \
      NULL, \
      LCOOS_VAREXP_BOOL, \
      "BOOL", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      0 \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "FILEDESCRIPTOR", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_FILEDESCRIPTOR), \
      sizeof(LC_TD_DINT), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_DINT, \
      "DINT", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      0 \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "FLAGS", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_FLAGS), \
      sizeof(LC_TD_DINT), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_DINT, \
      "DINT", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      0 \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "FLAGSCREATETRUNCWRITE", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_FLAGSCREATETRUNCWRITE), \
      sizeof(LC_TD_DINT), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_DINT, \
      "DINT", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      0 \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "FLAGSWRITEAPPEND", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_FLAGSWRITEAPPEND), \
      sizeof(LC_TD_DINT), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_DINT, \
      "DINT", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      0 \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "INIT", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_INIT), \
      sizeof(LC_TD_BOOL), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_BOOL, \
      "BOOL", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      0 \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "LINUX_O_APPEND", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_APPEND), \
      sizeof(LC_TD_DINT), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_DINT, \
      "DINT", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      LCOOS_VAREXP_FLAGS_CONST \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "LINUX_O_CREAT", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_CREAT), \
      sizeof(LC_TD_DINT), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_DINT, \
      "DINT", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      LCOOS_VAREXP_FLAGS_CONST \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "LINUX_O_EXCL", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_EXCL), \
      sizeof(LC_TD_DINT), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_DINT, \
      "DINT", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      LCOOS_VAREXP_FLAGS_CONST \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "LINUX_O_RDONLY", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_RDONLY), \
      sizeof(LC_TD_DINT), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_DINT, \
      "DINT", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      LCOOS_VAREXP_FLAGS_CONST \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "LINUX_O_RDWR", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_RDWR), \
      sizeof(LC_TD_DINT), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_DINT, \
      "DINT", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      LCOOS_VAREXP_FLAGS_CONST \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "LINUX_O_TRUNC", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_TRUNC), \
      sizeof(LC_TD_DINT), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_DINT, \
      "DINT", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      LCOOS_VAREXP_FLAGS_CONST \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "LINUX_O_WRONLY", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_WRONLY), \
      sizeof(LC_TD_DINT), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_DINT, \
      "DINT", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      LCOOS_VAREXP_FLAGS_CONST \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "MODE", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_MODE), \
      sizeof(LC_TD_DINT), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_DINT, \
      "DINT", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      0 \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "MY_STRING", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_MY_STRING), \
      65 * sizeof(LcCgChar), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_STRING, \
      "STRING", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      0 \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "WRITECOUNTER", \
      0, \
      offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_WRITECOUNTER), \
      sizeof(LC_TD_DINT), \
      LCOOS_VAREXP_VAR, \
      NULL, \
      LCOOS_VAREXP_DINT, \
      "DINT", \
      NULL, \
      NULL, \
      NULL, \
      NULL, \
      0 \
    }\
  }
#define LCNS_EL_CNT_FILEWRITEPROGRAM_NONDMA 17
#define LCNS_EL_CNT___FILEWRITEPROGRAM (LCNS_EL_CNT_FILEWRITEPROGRAM_NONDMA)

/*                            Prototype                        */
void  lcpu___FILEWRITEPROGRAM(LC_TD_Program_FILEWRITEPROGRAM* LC_this, struct _lcoplck_epdb_1_impl* pEPDB);

/* array nodes */
extern RTTypeNS_ArrayNode lcns_arrayNode___FILEWRITEPROGRAM_DATA;

#endif
