#include <RISMD.h>
#include <lcpu___filewriteprogram.h>

extern RISMDSimpleNumType const risMdType_BYTE;
RISMDArrayType const lcmd_type_FILEWRITEPROGRAM_DATA_ARR = INIT_RISMDArrayType(0,63,sizeof(LC_TD_BYTE),&risMdType_BYTE);
static char const lcmd_var_name_FILEWRITEPROGRAM_DATA[] = "data";
static RISMDStdVariable const lcmd_var_FILEWRITEPROGRAM_DATA =
INIT_RISMDStdVariable(lcmd_var_name_FILEWRITEPROGRAM_DATA, &lcmd_type_FILEWRITEPROGRAM_DATA_ARR, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_DATA));

extern RISMDSimpleNumType const risMdType_BOOL;
static char const lcmd_var_name_FILEWRITEPROGRAM_ENO[] = "ENO";
static RISMDInterfaceVariable const lcmd_var_FILEWRITEPROGRAM_ENO =
INIT_RISMDInterfaceVariable(lcmd_var_name_FILEWRITEPROGRAM_ENO, &risMdType_BOOL, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_ENO), RISMD_VARIABLE_SECTION_OUTPUT);

extern RISMDSimpleNumType const risMdType_DINT;
static char const lcmd_var_name_FILEWRITEPROGRAM_FILEDESCRIPTOR[] = "fileDescriptor";
static RISMDStdVariable const lcmd_var_FILEWRITEPROGRAM_FILEDESCRIPTOR =
INIT_RISMDStdVariable(lcmd_var_name_FILEWRITEPROGRAM_FILEDESCRIPTOR, &risMdType_DINT, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_FILEDESCRIPTOR));

static char const lcmd_var_name_FILEWRITEPROGRAM_FLAGS[] = "flags";
static RISMDStdVariable const lcmd_var_FILEWRITEPROGRAM_FLAGS =
INIT_RISMDStdVariable(lcmd_var_name_FILEWRITEPROGRAM_FLAGS, &risMdType_DINT, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_FLAGS));

static char const lcmd_var_name_FILEWRITEPROGRAM_FLAGSCREATETRUNCWRITE[] = "flagsCreateTruncWrite";
static RISMDStdVariable const lcmd_var_FILEWRITEPROGRAM_FLAGSCREATETRUNCWRITE =
INIT_RISMDStdVariable(lcmd_var_name_FILEWRITEPROGRAM_FLAGSCREATETRUNCWRITE, &risMdType_DINT, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_FLAGSCREATETRUNCWRITE));

static char const lcmd_var_name_FILEWRITEPROGRAM_FLAGSWRITEAPPEND[] = "flagsWriteAppend";
static RISMDStdVariable const lcmd_var_FILEWRITEPROGRAM_FLAGSWRITEAPPEND =
INIT_RISMDStdVariable(lcmd_var_name_FILEWRITEPROGRAM_FLAGSWRITEAPPEND, &risMdType_DINT, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_FLAGSWRITEAPPEND));

static char const lcmd_var_name_FILEWRITEPROGRAM_INIT[] = "INIT";
static RISMDStdVariable const lcmd_var_FILEWRITEPROGRAM_INIT =
INIT_RISMDStdVariable(lcmd_var_name_FILEWRITEPROGRAM_INIT, &risMdType_BOOL, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_INIT));

static char const lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_APPEND[] = "Linux_O_APPEND";
static RISMDStorageClassAttr const lcmd_attr_FILEWRITEPROGRAM_LINUX_O_APPEND_StorageClassAttr = INIT_RISMDStorageClassAttr(RISMD_STORAGE_CLASS_CONST);
static RISMDReference const lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_APPEND[] =
{
  INIT_RISMDReference(&lcmd_attr_FILEWRITEPROGRAM_LINUX_O_APPEND_StorageClassAttr),
};
static RISMDStdAttrVariable const lcmd_var_FILEWRITEPROGRAM_LINUX_O_APPEND =
INIT_RISMDStdAttrVariable(lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_APPEND, &risMdType_DINT, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_APPEND),1,lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_APPEND);

static char const lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_CREAT[] = "Linux_O_CREAT";
static RISMDStorageClassAttr const lcmd_attr_FILEWRITEPROGRAM_LINUX_O_CREAT_StorageClassAttr = INIT_RISMDStorageClassAttr(RISMD_STORAGE_CLASS_CONST);
static RISMDReference const lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_CREAT[] =
{
  INIT_RISMDReference(&lcmd_attr_FILEWRITEPROGRAM_LINUX_O_CREAT_StorageClassAttr),
};
static RISMDStdAttrVariable const lcmd_var_FILEWRITEPROGRAM_LINUX_O_CREAT =
INIT_RISMDStdAttrVariable(lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_CREAT, &risMdType_DINT, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_CREAT),1,lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_CREAT);

static char const lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_EXCL[] = "Linux_O_EXCL";
static RISMDStorageClassAttr const lcmd_attr_FILEWRITEPROGRAM_LINUX_O_EXCL_StorageClassAttr = INIT_RISMDStorageClassAttr(RISMD_STORAGE_CLASS_CONST);
static RISMDReference const lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_EXCL[] =
{
  INIT_RISMDReference(&lcmd_attr_FILEWRITEPROGRAM_LINUX_O_EXCL_StorageClassAttr),
};
static RISMDStdAttrVariable const lcmd_var_FILEWRITEPROGRAM_LINUX_O_EXCL =
INIT_RISMDStdAttrVariable(lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_EXCL, &risMdType_DINT, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_EXCL),1,lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_EXCL);

static char const lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_RDONLY[] = "Linux_O_RDONLY";
static RISMDStorageClassAttr const lcmd_attr_FILEWRITEPROGRAM_LINUX_O_RDONLY_StorageClassAttr = INIT_RISMDStorageClassAttr(RISMD_STORAGE_CLASS_CONST);
static RISMDReference const lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_RDONLY[] =
{
  INIT_RISMDReference(&lcmd_attr_FILEWRITEPROGRAM_LINUX_O_RDONLY_StorageClassAttr),
};
static RISMDStdAttrVariable const lcmd_var_FILEWRITEPROGRAM_LINUX_O_RDONLY =
INIT_RISMDStdAttrVariable(lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_RDONLY, &risMdType_DINT, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_RDONLY),1,lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_RDONLY);

static char const lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_RDWR[] = "Linux_O_RDWR";
static RISMDStorageClassAttr const lcmd_attr_FILEWRITEPROGRAM_LINUX_O_RDWR_StorageClassAttr = INIT_RISMDStorageClassAttr(RISMD_STORAGE_CLASS_CONST);
static RISMDReference const lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_RDWR[] =
{
  INIT_RISMDReference(&lcmd_attr_FILEWRITEPROGRAM_LINUX_O_RDWR_StorageClassAttr),
};
static RISMDStdAttrVariable const lcmd_var_FILEWRITEPROGRAM_LINUX_O_RDWR =
INIT_RISMDStdAttrVariable(lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_RDWR, &risMdType_DINT, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_RDWR),1,lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_RDWR);

static char const lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_TRUNC[] = "Linux_O_TRUNC";
static RISMDStorageClassAttr const lcmd_attr_FILEWRITEPROGRAM_LINUX_O_TRUNC_StorageClassAttr = INIT_RISMDStorageClassAttr(RISMD_STORAGE_CLASS_CONST);
static RISMDReference const lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_TRUNC[] =
{
  INIT_RISMDReference(&lcmd_attr_FILEWRITEPROGRAM_LINUX_O_TRUNC_StorageClassAttr),
};
static RISMDStdAttrVariable const lcmd_var_FILEWRITEPROGRAM_LINUX_O_TRUNC =
INIT_RISMDStdAttrVariable(lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_TRUNC, &risMdType_DINT, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_TRUNC),1,lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_TRUNC);

static char const lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_WRONLY[] = "Linux_O_WRONLY";
static RISMDStorageClassAttr const lcmd_attr_FILEWRITEPROGRAM_LINUX_O_WRONLY_StorageClassAttr = INIT_RISMDStorageClassAttr(RISMD_STORAGE_CLASS_CONST);
static RISMDReference const lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_WRONLY[] =
{
  INIT_RISMDReference(&lcmd_attr_FILEWRITEPROGRAM_LINUX_O_WRONLY_StorageClassAttr),
};
static RISMDStdAttrVariable const lcmd_var_FILEWRITEPROGRAM_LINUX_O_WRONLY =
INIT_RISMDStdAttrVariable(lcmd_var_name_FILEWRITEPROGRAM_LINUX_O_WRONLY, &risMdType_DINT, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_LINUX_O_WRONLY),1,lcmd_attr_list_FILEWRITEPROGRAM_LINUX_O_WRONLY);

static char const lcmd_var_name_FILEWRITEPROGRAM_MODE[] = "mode";
static RISMDStdVariable const lcmd_var_FILEWRITEPROGRAM_MODE =
INIT_RISMDStdVariable(lcmd_var_name_FILEWRITEPROGRAM_MODE, &risMdType_DINT, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_MODE));

RISMDStringType const lcmd_type_FILEWRITEPROGRAM_MY_STRING_STR = INIT_RISMDStringType(65);
static char const lcmd_var_name_FILEWRITEPROGRAM_MY_STRING[] = "my_string";
static RISMDStdVariable const lcmd_var_FILEWRITEPROGRAM_MY_STRING =
INIT_RISMDStdVariable(lcmd_var_name_FILEWRITEPROGRAM_MY_STRING, &lcmd_type_FILEWRITEPROGRAM_MY_STRING_STR, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_MY_STRING));

static char const lcmd_var_name_FILEWRITEPROGRAM_WRITECOUNTER[] = "writeCounter";
static RISMDStdVariable const lcmd_var_FILEWRITEPROGRAM_WRITECOUNTER =
INIT_RISMDStdVariable(lcmd_var_name_FILEWRITEPROGRAM_WRITECOUNTER, &risMdType_DINT, offsetof(LC_TD_Program_FILEWRITEPROGRAM,LC_VD_WRITECOUNTER));

static RISMDReference const lcmd_var_list_FILEWRITEPROGRAM[] =
{
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_DATA),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_ENO),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_FILEDESCRIPTOR),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_FLAGS),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_FLAGSCREATETRUNCWRITE),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_FLAGSWRITEAPPEND),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_INIT),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_LINUX_O_APPEND),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_LINUX_O_CREAT),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_LINUX_O_EXCL),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_LINUX_O_RDONLY),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_LINUX_O_RDWR),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_LINUX_O_TRUNC),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_LINUX_O_WRONLY),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_MODE),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_MY_STRING),
  INIT_RISMDReference(&lcmd_var_FILEWRITEPROGRAM_WRITECOUNTER),
};

static char const lcmd_type_name_FILEWRITEPROGRAM[] = "FILEWRITEPROGRAM";
RISMDPOUType const lcmd_type_FILEWRITEPROGRAM = INIT_RISMDPOUType(lcmd_type_name_FILEWRITEPROGRAM, sizeof(LC_TD_Program_FILEWRITEPROGRAM), 17, lcmd_var_list_FILEWRITEPROGRAM);
