/* Copyright (C) logi.cals GmbH. All rights reserved. */

/*
** TASK      :: Nameserver Definition Table
** NOTES     ::
*/

/***************************************************************************
** Global Includes, Defines , Types
****************************************************************************/
#include <RTNameServer.h>
#include <RTSSIOGeneric.h>
#include <RTIODriverParam.h>
#include <NSTimeStamp.h>
#include <lcpu___filewriteprogram.h>


#ifndef ARR_EL_CNT
#define ARR_EL_CNT(arr) (sizeof(arr)/sizeof(arr[0]))
#endif

char const* ns_getrevision(void)
{
  return LC_NS_TIMESTAMP;
}

static struct _struct_ns_naddress s_paddress_list[] = {
  {0,0,0,0}
};





#define LCNS_TNREF___FILEWRITEPROGRAM (s_type_nodes + 0)

extern const RTTypeNS_TypeNode s_type_nodes[];

#if LCNS_EL_CNT___FILEWRITEPROGRAM
static const RTTypeNS_ElementNode s_element_nodes_FILEWRITEPROGRAM[] = LCNS_EL_INI___FILEWRITEPROGRAM;
#else
#define s_element_nodes_FILEWRITEPROGRAM NULL
#endif


const RTTypeNS_TypeNode s_type_nodes[] = {
{ sizeof(RTTypeNS_TypeNode),"instanceName_FILEWRITEPROGRAM",LCNS_EL_CNT___FILEWRITEPROGRAM,s_element_nodes_FILEWRITEPROGRAM,0 }
};

static const RTTypeNS_InstanceNode s_instance_nodes[] = {
   { sizeof(RTTypeNS_InstanceNode),"INSTANCENAME",256,LCOOS_VAREXP_PRG_INST,LCNS_TNREF___FILEWRITEPROGRAM,0 }
};


int ns_get_typecount(void)
{
  return ARR_EL_CNT(s_type_nodes);
}

RTTypeNS_TypeNode const* ns_get_types(void)
{
  return s_type_nodes;
}

int ns_get_instancecount(void)
{
  return ARR_EL_CNT(s_instance_nodes);
}

RTTypeNS_InstanceNode const* ns_get_instances(void)
{
  return s_instance_nodes;
}

static const RTNameResolvingData3 global_NameserverData3 =
{
 {sizeof(RTNameResolvingData3),RTS_NS_STRUCT_VER_TypeNS,RTS_NS_FLAG_SUPPORT_ARRAY}
,LC_NS_TIMESTAMP
,ARR_EL_CNT(s_instance_nodes),s_instance_nodes
,ARR_EL_CNT(s_type_nodes),s_type_nodes
};

/* Generic I/O Data */
static const RTSS_IO_Generic_Config global_GenericIO =
{0,0,0};

/* Retained Data Information */
static const unsigned long global_RetainedDataVersion = 4294967295UL;

static const unsigned long global_fingerprint =
#include <Fingerprint.inc>
;

static char const global_codeImgMd[] =
#include <CodeImgMd.inc>
;
