#ifndef LC_PROT_LCFU_LOGILIBRARY__SYSTEM_WRITE__H
#define LC_PROT_LCFU_LOGILIBRARY__SYSTEM_WRITE__H

#include <LC3CGBase.h>

/*                            Typedefs                         */
typedef struct _LC_TD_Function_SYSTEM_WRITE
{
  LC_TD_BOOL LC_VD_ENO;
  LC_TD_DINT LC_VD_ERRNO;
  LC_TD_DINT LC_VD_SYSTEM_WRITE;
  LC_TD_DINT LC_VD_RC;
} LCCG_StructAttrib LC_TD_Function_SYSTEM_WRITE;

/*                            Initialization Macro             */
#define LC_INIT_Function_SYSTEM_WRITE(p) \
{ \
  LC_INIT_DINT(&((p)->LC_VD_SYSTEM_WRITE)); \
  LC_INIT_DINT(&((p)->LC_VD_ERRNO)); \
  LC_INIT_DINT(&((p)->LC_VD_RC)); \
}

/*                            Prototype                        */
void lcfu_logilibrary_WRITE(LC_TD_Function_SYSTEM_WRITE* LC_this, LC_TD_DINT LC_VD_FD, LC_TD_DINT LC_VD_COUNT, LC_TD_BYTE* LC_VD_DATA, size_t dataSize, struct _lcoplck_epdb_1_impl* pEPDB);

#define lcfu_logilibrary__SYSTEM_WRITE(LC_this,fd,count,dest,pEPDB) \
    lcfu_logilibrary_WRITE((LC_this),(fd),(count),&((*(dest))[0]),sizeof(*(dest)),(pEPDB))

#endif
